package service

import model.User

class AdminServiceImpl(private val authorizationList: MutableList<User>, private val passwordService: IPasswordService) : IAdminService {

    override fun getAllUsers(): List<User> {
        return authorizationList.toList()
    }

    override fun getAllUsersSort(): List<User> {
        return authorizationList.sortedByDescending { it.lastAuthorizeDate }
    }

    override fun updateUserPassword(email: String, newPassword: String): Boolean {
        val user = authorizationList.find { it.email == email }
        require(user != null) {
            return false
        }

        user.password = passwordService.hashPassword(newPassword)
        return true
    }

    override fun removeUserById(userId: Int): Boolean {
        return authorizationList.removeIf { it.userId == userId }
    }
}