package service

import java.util.*
import javax.crypto.SecretKeyFactory
import javax.crypto.spec.PBEKeySpec

class PasswordService : IPasswordService{
    private val HASH_LENGTH = 256
    private val ITERATIONS = 65536
    private val salt = "sosalt"

    override fun hashPassword(password: String): String {
        val saltBytes = Base64.getDecoder().decode(salt)
        val spec = PBEKeySpec(password.toCharArray(), saltBytes, ITERATIONS, HASH_LENGTH)
        val factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA256")
        val hash = factory.generateSecret(spec).encoded
        return Base64.getEncoder().encodeToString(hash)
    }

    override fun matches(password: String, hashedPassword: String): Boolean {
        val hash = hashPassword(password)
        return hash == hashedPassword
    }
}